#include "FPS.h"

FPS::FPS(float interval)
:	interval( interval ),
	fps( 0 )
{}

FPS::~FPS()
{}

float FPS::get_fps()const
{
	return fps;
}

void FPS::record(float time)
{
	records.push_back( time );

	while( records.front() + interval < time )
		records.pop_front();

	float dt = time - records.front();
	fps = (dt == 0) ? 0 : records.size() / dt;
}
