#include "Game.h"
#include "Level.h"
#include "Pacman.h"
#include <Converter.h>

Game::Game(Scene2D * scene)
:	scene( scene ),
	pacman( 0 ),
	level( 0 ),
	score_text( scene, 3, "data\\small_alphabet" ),
	lives_text( scene, 3, "data\\small_alphabet" )
{
	level = new Level( scene );
	pacman = new Pacman( scene );
	pacman->put_on_level( level );
	level->add_external_creature( pacman );

	score_text.move( 10, 220 );
	score_text.change_text( "0" );

	lives_text.move( 180, 220 );
	lives_text.change_text( "0" );
}

Game::~Game()
{
	delete level; level = 0;
	delete pacman; pacman = 0;
}

void Game::life_cycle(float delta_time)
{
	if ( level )
		level->life_cycle( delta_time );
	if ( pacman )
	{
		score_text.change_text( String("Score: ") + Converter::convert( int(pacman->get_score()) ) );
		lives_text.change_text( String("Lives: ") + Converter::convert( int(pacman->get_life()) ) );
	}
}

void Game::key_up(int scan_code)
{
	if ( pacman )
		pacman->key_up( scan_code );
}

void Game::key_down(int scan_code)
{
	if ( pacman )
		pacman->key_down( scan_code );
}
