#ifndef LEVEL_H
#define LEVEL_H

#include "Creatures.h"
#include <Array2D.h>
#include <2D/Animation2D.h>
class Position;
class Cell;
//class Scene2D;

class Level
{
public:
	Level(Scene2D * scene);
	virtual ~Level();

	bool next_direction( Creature * creature, Direction direction );
	void life_cycle(float delta_time);
	void add_external_creature(Creature * cre);
	void move( Creature * creature, const String & where );
	int get_cell_size()const;
private:	
	Creatures external_creatures;
	Creatures creatures;
	Array2D < Cell * > cells;
	Scene2D * const scene;

	Animation2D wall_size_anim;

	Coord pacman_start;
	Coord monster_start;

	bool load_level( const char * level_name );
};

#endif //LEVEL_H